#!/bin/sh

cat floppy/grub/menu-base.lst > floppy/grub/menu.lst

for entry in `ls floppy/entries`; do
	echo "$entry"
	
	# Add this entry to main menu
	cat floppy/entries/$entry/main-menu.lst >> floppy/grub/menu.lst
	echo "configfile (fd0)/entries/$entry/menu.lst" >> floppy/grub/menu.lst
	echo >> floppy/grub/menu.lst
	
	# Create this entry's menu.
	menufile="floppy/entries/$entry/menu.lst"
	
	desclen="$(fold -s -w 65 "floppy/entries/$entry/description" | wc -l)"
	
	echo "default $((desclen+4))"                             >  $menufile
	echo                                                      >> $menufile
	
	echo -n "title Author   : "                               >> $menufile
	cat floppy/entries/$entry/author                          >> $menufile
	echo                                                      >> $menufile
	echo "quiet"                                              >> $menufile
	echo                                                      >> $menufile
	
	echo -n "title Name     : "                               >> $menufile
	cat floppy/entries/$entry/name                            >> $menufile
	echo                                                      >> $menufile
	echo "quiet"                                              >> $menufile
	echo                                                      >> $menufile
	
	echo -n "title Length   : "                               >> $menufile
	cat floppy/entries/$entry/length                          >> $menufile
	echo -n " of 510"                                         >> $menufile
	echo                                                      >> $menufile
	echo "quiet"                                              >> $menufile
	echo                                                      >> $menufile
	
	echo "title Description :"                                >> $menufile
	echo "quiet"                                              >> $menufile
	fold -s -w 65 "floppy/entries/$entry/description" \
	| while read -r ab; do
		echo "title    $ab"                              >> $menufile
		echo "quiet"                                      >> $menufile
	done
	echo                                                      >> $menufile
	
	echo "title Start it !"                                   >> $menufile
	echo "chainloader (fd0)/entries/$entry/sector/sector.512" >> $menufile
	echo                                                      >> $menufile
	
	echo "title View source"                                  >> $menufile
	sh splitlines.sh "$entry"                                 >> $menufile
	echo                                                      >> $menufile
	
	echo "title Back to main menu"                            >> $menufile
	echo "configfile (fd0)/grub/menu.lst"                     >> $menufile
done
